function pos_customize_product_pack_models(instance, module){
    var QWeb = instance.web.qweb;
    _t = instance.web._t;

    var PosModelSuper = module.PosModel;
    module.PosModel = module.PosModel.extend({
        load_server_data: function(){
            var self = this;
            var loaded = PosModelSuper.prototype.load_server_data.call(this);
            loaded = loaded.then(function(){
                return self.fetch(
                    'product.product',
                    ['pack_line_ids'],
                    [['sale_ok','=',true],['available_in_pos','=',true]],
                    {}
                );
            }).then(function(products){
                $.each(products, function(){
                    $.extend(self.db.get_product_by_id(this.id) || {}, this);
                });
                return $.when();
            });
            return loaded;
        },
    });

    module.PosModel.prototype.models.push({
        model: "product.pack.line",
        fields: ['parent_product_id', 'product_id'],
        loaded: function(self, product_pack_lines){
            self.product_pack_lines = product_pack_lines;
        },
    });

    var OrderSuper = module.Order;
    module.Order = module.Order.extend({
        addProduct: function(product, options){
            if(this._printed){
                this.destroy();
                return this.pos.get('selectedOrder').addProduct(product, options);
            }
            options = options || {};
            var attr = JSON.parse(JSON.stringify(product));
            attr.pos = this.pos;
            attr.order = this;
            var line = new module.Orderline({}, {pos: this.pos, order: this, product: product});

            if(options.quantity !== undefined){
                line.set_quantity(options.quantity);
            }
            if(options.price !== undefined){
                line.set_unit_price(options.price);
            }
            if(options.discount !== undefined){
                line.set_discount(options.discount);
            }

            var last_orderline = this.getLastOrderline();
            if(last_orderline != undefined){
                var packlines = last_orderline.product.pack_line_ids;
                if(last_orderline && last_orderline.can_be_merged_with(line) && options.merge !== false && packlines.length == 0){
                    last_orderline.merge(line);
                }else{
                   this.get('orderLines').add(line); 
                }
            }else{
                this.get('orderLines').add(line);
            }
            this.selectLine(this.getLastOrderline());
        },
    });

    var orderline_id = 1;
    module.Orderline = module.Orderline.extend({
        initialize: function(attr,options){
            this.pos = options.pos;
            this.order = options.order;
            this.product = options.product;
            this.price   = options.product.price;
            this.set_quantity(1);
            this.discount = 0;
            this.discountStr = '0';
            this.type = 'unit';
            this.selected = false;
            this.id       = orderline_id++;
            this.pack_lines = [];
        },
    });
};

